#include "ell/StateCollector.hh"

namespace ell
{

	SC_Maximum::SC_Maximum()
	  : SC_Counting(), maxEState(NULL)
	{
	}
	
	SC_Maximum::~SC_Maximum()
	{
		if (maxEState != NULL)
			delete maxEState;
	}

	  // This function is used to track all added intermediate States.
	  // @param s the added State
	void 
	SC_Maximum::add(const State& s) {
		
		  // check if current maximal energy state is smaller than s
		if (maxEState == NULL || maxEState->operator<(s)) {
			maxEState = s.clone(maxEState);
		}
		
		  // forward to super class
		SC_Counting::add(s);
	}
	
	

	  // Returns the maximal State seen so far
	  // @return the State 
	const State* const
	SC_Maximum::getMaximumState() const {
		return maxEState;
	}
	

}
