#include "ell/StateCollector.hh"

namespace ell
{

	SC_Outstream::SC_Outstream(	std::ostream& out_, 
								const std::string& labelAdded)
	 :	SC_Counting(), out(out_), strAdded(labelAdded)
	{
	}
	
	SC_Outstream::~SC_Outstream()
	{
		out.flush();
	}

	  // This function is used to track all added intermediate States.
	  // @param s the added State
	void 
	SC_Outstream::add(const State& s) {
		  //  call handler of superclass
		SC_Counting::add(s);
		  // print to stream
		out	<<s.toString() 
			<<strAdded;
	}

}
